
-- | The beginnings of a Stockholm File parser.

module Biobase.Infernal.Stockholm where

-- | Stockholm format data. We have a set of sequences with sequence data, a
-- set of column annotations and unknown data (actually: known, but we do not
-- care).

data Stockholm = Stockholm
  { sequences :: [(String,String)]
  , colAnnotations :: [(String,String)]   -- #=GC tag
  , exAnnotations :: [(String,String)]    -- NOTE this is not in the Stockholm format!
  , unknown :: [String]
  }
  deriving (Show)
